/*
    省市区三级级联菜单
    new Cascade(province,city,district) 初始化级联菜单
        @province string 省份select元素id
        @city     string 城市select元素id
        @district string 区域select元素id
    select 根据传入的参数,生成相应省市区的级联菜单，并选中
        select(province,city,district)
        @province string 省份值
        @city     string 城市值
        @district string 地区值
*/
define(function(require) {        
    function Cascade(province,city,district){
        this.init(province,city,district)
    };
    var data={
        province:["北京", "上海", "天津", "重庆", "河北", "山西", "河南", "辽宁", "吉林", "黑龙江", "内蒙古", "江苏", "山东", "安徽", "浙江", "福建", "湖北", "湖南", "广东", "广西", "江西", "四川", "海南", "贵州", "云南", "西藏", "陕西", "甘肃", "青海", "宁夏", "新疆", "台湾", "香港", "澳门", "钓鱼岛"],
        city:{"北京":["朝阳区","海淀区","西城区","东城区","崇文区","宣武区","丰台区","石景山区","门头沟","房山区","通州区","大兴区","顺义区","怀柔区","密云区","昌平区","平谷区","延庆县"],"上海":["黄浦区","卢湾区","徐汇区","长宁区","静安区","闸北区","虹口区","杨浦区","宝山区","闵行区","嘉定区","浦东新区","青浦区","松江区","金山区","南汇区","奉贤区","普陀区","崇明县"],"天津":["东丽区","和平区","河北区","河东区","河西区","红桥区","蓟县","静海县","南开区","塘沽区","西青区","武清区","津南区","汉沽区","大港区","北辰区","宝坻区","宁河县"],"重庆":["万州区","涪陵区","梁平县","南川区","潼南县","大足区","黔江区","武隆县","丰都县","奉节县","开县","云阳县","忠县","巫溪县","巫山县","石柱县","彭水县","垫江县","酉阳县","秀山县","城口县","璧山县","荣昌县","铜梁县","合川区","巴南区","北碚区","江津区","渝北区","长寿区","永川区","江北区","南岸区","九龙坡区","沙坪坝区","大渡口区","綦江区","渝中区","高新区","北部新区"],"河北":["石家庄市","邯郸市","邢台市","保定市","张家口市","承德市","秦皇岛市","唐山市","沧州市","廊坊市","衡水市"],"山西":["太原市","大同市","阳泉市","晋城市","朔州市","晋中市","忻州市","吕梁市","临汾市","运城市","长治市"],"河南":["郑州市","开封市","洛阳市","平顶山市","焦作市","鹤壁市","新乡市","安阳市","濮阳市","许昌市","漯河市","三门峡市","南阳市","商丘市","周口市","驻马店市","信阳市","济源市"],"辽宁":["沈阳市","大连市","鞍山市","抚顺市","本溪市","丹东市","锦州市","葫芦岛市","营口市","盘锦市","阜新市","辽阳市","朝阳市","铁岭市"],"吉林":["长春市","吉林市","四平市","通化市","白山市","松原市","白城市","延边州","辽源市"],"黑龙江":["哈尔滨市","齐齐哈尔市","鹤岗市","双鸭山市","鸡西市","大庆市","伊春市","牡丹江市","佳木斯市","七台河市","黑河市","绥化市","大兴安岭地区"],"内蒙古":["呼和浩特市","包头市","乌海市","赤峰市","乌兰察布市","锡林郭勒盟","呼伦贝尔市","鄂尔多斯市","巴彦淖尔市","阿拉善盟","兴安盟","通辽市"],"江苏":["南京市","徐州市","连云港市","淮安市","宿迁市","盐城市","扬州市","泰州市","南通市","镇江市","常州市","无锡市","苏州市"],"山东":["济南市","青岛市","淄博市","枣庄市","东营市","潍坊市","烟台市","威海市","莱芜市","德州市","临沂市","聊城市","滨州市","菏泽市","日照市","泰安市","济宁市"],"安徽":["铜陵市","合肥市","淮南市","淮北市","芜湖市","蚌埠市","马鞍山市","安庆市","黄山市","滁州市","阜阳市","亳州市","宿州市","池州市","六安市","宣城市"],"浙江":["宁波市","杭州市","温州市","嘉兴市","湖州市","绍兴市","金华市","衢州市","丽水市","台州市","舟山市"],"福建":["福州市","厦门市","三明市","莆田市","泉州市","漳州市","南平市","龙岩市","宁德市"],"湖北":["武汉市","黄石市","襄阳市","十堰市","荆州市","宜昌市","孝感市","黄冈市","咸宁市","恩施州","鄂州市","荆门市","随州市","潜江市","天门市","仙桃市","神农架林区"],"湖南":["长沙市","株洲市","湘潭市","韶山市","衡阳市","邵阳市","岳阳市","常德市","张家界市","郴州市","益阳市","永州市","怀化市","娄底市","湘西州"],"广东":["广州市","深圳市","珠海市","汕头市","韶关市","河源市","梅州市","惠州市","汕尾市","东莞市","中山市","江门市","佛山市","阳江市","湛江市","茂名市","肇庆市","云浮市","清远市","潮州市","揭阳市"],"广西":["南宁市","柳州市","桂林市","梧州市","北海市","防城港市","钦州市","贵港市","玉林市","贺州市","百色市","河池市","来宾市","崇左市"],"江西":["南昌市","景德镇市","萍乡市","新余市","九江市","鹰潭市","上饶市","宜春市","抚州市","吉安市","赣州市"],"四川":["成都市","自贡市","攀枝花市","泸州市","绵阳市","德阳市","广元市","遂宁市","内江市","乐山市","宜宾市","广安市","南充市","达州市","巴中市","雅安市","眉山市","资阳市","阿坝州","甘孜州","凉山州"],"海南":["海口市","儋州市","琼海市","万宁市","东方市","三亚市","文昌市","五指山市","临高县","澄迈县","定安县","屯昌县","昌江县","白沙县","琼中县","陵水县","保亭县","乐东县","三沙市"],"贵州":["贵阳市","六盘水市","遵义市","铜仁市","毕节市","安顺市","黔西南州","黔东南州","黔南州"],"云南":["昆明市","曲靖市","玉溪市","昭通市","普洱市","临沧市","保山市","丽江市","文山州","红河州","西双版纳州","楚雄州","大理州","德宏州","怒江州","迪庆州"],"西藏":["拉萨市","那曲地区","山南地区","昌都地区","日喀则地区","阿里地区","林芝地区"],"陕西":["西安市","铜川市","宝鸡市","咸阳市","渭南市","延安市","汉中市","榆林市","商洛市","安康市"],"甘肃":["兰州市","金昌市","白银市","天水市","嘉峪关市","平凉市","庆阳市","陇南市","武威市","张掖市","酒泉市","甘南州","临夏州","定西市"],"青海":["西宁市","海东地区","海北州","黄南州","海南州","果洛州","玉树州","海西州"],"宁夏":["银川市","石嘴山市","吴忠市","固原市","中卫市"],"新疆":["乌鲁木齐市","克拉玛依市","石河子市","吐鲁番地区","哈密地区","和田地区","阿克苏地区","喀什地区","克孜勒苏州","巴音郭楞州","昌吉州","博尔塔拉州","伊犁州","塔城地区","阿勒泰地区","五家渠市","阿拉尔市","图木舒克市"],"台湾":["台湾"],"香港":["香港特别行政区"],"澳门":["澳门市"],"钓鱼岛":["钓鱼岛"]},
        district:{"北京 朝阳区":["三环以内","三环到四环之间","四环到五环之间","五环到六环之间","管庄","北苑","定福庄"],"北京 海淀区":["三环以内","三环到四环之间","四环到五环之间","五环到六环之间","六环以外","西三旗","西二旗"],"北京 西城区":["内环到二环里","二环到三环"],"北京 东城区":["内环到三环里"],"北京 崇文区":["一环到二环","二环到三环"],"北京 宣武区":["内环到三环里"],"北京 丰台区":["四环到五环之间","二环到三环","三环到四环之间","五环到六环之间","六环之外"],"北京 石景山区":["四环到五环内","石景山城区","八大处科技园区"],"北京 门头沟":["郊区","城区以内"],"北京 房山区":["郊区","城区以内"],"北京 通州区":['六环内（马驹桥镇）','中仓街道','新华街道','玉桥街道','北苑街道','六环外（马驹桥镇）','永顺镇','梨园镇','宋庄镇','漷县镇','张家湾镇','西集镇','永乐店镇','潞城镇','台湖镇','于家务乡','次渠镇'
],"北京 大兴区":["四环至五环之间","六环以外","五环至六环之间","亦庄经济开发区"],"北京 顺义区":["北石槽镇","北务镇","北小营镇","大孙各庄镇","高丽营镇","光明街道","后沙峪地区","空港街道","李桥镇","李遂镇","龙湾屯镇","马坡地区","木林镇","南彩镇","南法信地区","牛栏山地区","仁和地区","胜利街道","石园街道","双丰街道","天竺地区","旺泉街道","杨镇地区","张镇","赵全营镇"],"北京 怀柔区":["郊区","城区以内"],"北京 密云区":["城区以外","城区"],"北京 昌平区":["城区以外","六环以内","城区"],"北京 平谷区":["城区以外","城区"],"北京 延庆县":["百泉路南,京新高速北,康张路西,京银路东","百泉路北,京新高速南,康张路东,京银路西"],"上海 黄浦区":["内环以内","内环中环之间","中环外环之间"],"上海 卢湾区":["内环中环之间","内环以内","中环外环之间"],"上海 徐汇区":["内环以内","内环中环之间"],"上海 长宁区":["内环以内","内环中环之间","中环外环之间"],"上海 静安区":["内环以内","内环中环之间","中环外环之间"],"上海 闸北区":["内环以内","中环外环之间","内环中环之间"],"上海 虹口区":["内环中环之间","内环以内","中环外环之间"],"上海 杨浦区":["内环以内","内环中环之间","中环外环之间"],"上海 宝山区":["中环以内","中环外环之间","外环以外"],"上海 闵行区":["中环以内","外环以外","中环外环之间"],"上海 嘉定区":["外环以外"],"上海 浦东新区":["中环以内","外环以外","中环外环之间"],"上海 青浦区":["外环以外"],"上海 松江区":["外环以外"],"上海 金山区":["外环以外"],"上海 南汇区":["祝桥镇","新场镇","惠南镇","康桥镇","宣桥镇","书院镇","大团镇","周浦镇","芦潮港镇","泥城镇","六灶镇","航头镇","万祥镇","老港镇","申港街道","临港新城"],"上海 奉贤区":["外环以外"],"上海 普陀区":["内环以内","内环中环之间","中环外环之间","桃浦新村"],"上海 崇明县":["堡镇","庙镇","陈家镇","城桥镇","东平镇","港西镇","港沿镇","建设镇","绿华镇","三星镇","竖新镇","向化镇","新海镇","新河镇","中兴镇","长兴乡","横沙乡","新村乡"],"天津 东丽区":["全境"],"天津 和平区":["全境"],"天津 河北区":["全境"],"天津 河东区":["全境"],"天津 河西区":["全境"],"天津 红桥区":["全境"],"天津 蓟县":["全境"],"天津 静海县":["全境"],"天津 南开区":["全境"],"天津 塘沽区":["全境"],"天津 西青区":["其它地区","杨柳青,中北,精武,大寺镇,环外海泰及外环内"],"天津 武清区":["杨村镇、下朱庄内","其它地区"],"天津 津南区":["咸水沽镇、海河教育园，海河科技园","双港，辛庄","其他地区"],"天津 汉沽区":["汉沽区街里、汉沽开发区","其它地区"],"天津 大港区":["大港油田","主城区内","主城区外"],"天津 北辰区":["外环内","外环外双街镇，河北工大新校，屈店工业园","外环外其它地区"],"天津 宝坻区":["城关镇、马家店开发区、天宝工业园","其它地区"],"天津 宁河县":["芦台镇、经济开发区、贸易开发区","其它地区"],"重庆 万州区":['陈家坝街道','钟鼓楼街道','周家坝街道','百安坝街道','高笋塘街道','双河口街道','龙都街道','牌楼街道','沙河街道','太白街道','五桥街道','白土镇','白羊镇','大周镇','弹子镇','分水镇','甘宁镇','高峰镇','高梁镇','后山镇','李河镇','龙驹镇','龙沙镇','罗田镇','孙家镇','太安镇','太龙镇','天城镇','武陵镇','响水镇','小周镇','新田镇','新乡镇','熊家镇','余家镇','长岭镇','长坪镇','长滩镇','走马镇','瀼渡镇','茨竹乡','柱山乡','燕山乡','溪口乡','普子乡','地宝乡','铁峰乡','黄柏乡','九池乡','梨树项','郭村乡','恒合乡'
],"重庆 涪陵区":["荔枝街道","敦仁街道","江北街道","江东街道","崇义街道","李渡镇","白涛镇","百胜镇","堡子镇","焦石镇","蔺市镇","龙桥镇","龙潭镇","马武镇","南沱镇","青羊镇","清溪镇","石沱镇","新妙镇","义和镇","增福乡","珍溪镇","镇安镇","致韩镇","土地坡乡","武陵山乡","中峰乡","梓里乡","丛林乡","大木乡","惠民乡","酒店乡","聚宝乡","卷洞乡","两汇乡","罗云乡","明家乡","仁义乡","山窝乡","石和乡","石龙乡","太和乡","天台乡","同乐乡","新村乡"],"重庆 梁平县":["梁山镇","柏家镇","碧山镇","大观镇","福禄镇","合兴镇","和林镇","虎城镇","回龙镇","金带镇","聚奎镇","礼让镇","龙门镇","明达镇","蟠龙镇","屏锦镇","仁贤镇","石安镇","文化镇","新盛镇","荫平镇","袁驿镇","云龙镇","竹山镇","安胜乡","铁门乡","紫照乡","曲水乡","龙胜乡","城北乡","城东乡","复平乡","县城内"],"重庆 南川区":["东城街道","南城街道","西城街道","太平场镇","大观镇","大有镇","合溪镇","金山镇","鸣玉镇","南平镇","三泉镇","神童镇","石墙镇","水江镇","头渡镇","兴隆镇","冷水关乡","德隆乡","峰岩乡","福寿乡","古花乡","河图乡","民主乡","木凉乡","乾丰乡","庆元乡","石莲乡","石溪乡","铁村乡","土溪乡","鱼泉乡","中桥乡"],"重庆 潼南县":["桂林街道","梓潼街道","柏梓镇","宝龙镇","崇龛镇","古溪镇","龙形镇","米心镇","群力镇","上和镇","双江镇","太安镇","塘坝镇","卧佛镇","五桂镇","小渡镇","新胜镇","玉溪镇","别口乡","田家乡","寿桥乡","县城内"],"重庆 大足区":["龙岗街道","棠香街道","龙滩子街道","龙水镇","智凤镇","宝顶镇","中敖镇","三驱镇","宝兴镇","玉龙镇","石马镇","拾万镇","回龙镇","金山镇","万古镇","国梁镇","雍溪镇","珠溪镇","龙石镇","邮亭镇","铁山镇","高升镇","季家镇","古龙镇","高坪镇","双路镇","通桥镇"],"重庆 黔江区":["城西街道","城东街道","城南街道","正阳街道","舟白街道","阿蓬江镇","小南海镇","鹅池镇","冯家镇","黑溪镇","黄溪镇","金溪镇","黎水镇","邻鄂镇","马喇镇","石会镇","石家镇","濯水镇","白石乡","白土乡","金洞乡","蓬东乡","沙坝乡","杉岭乡","水市乡","水田乡","太极乡","五里乡","新华乡","中塘乡"],"重庆 武隆县":["仙女山镇","巷口镇","白马镇","火炉镇","江口镇","平桥镇","桐梓镇","土坎镇","鸭江镇","羊角镇","长坝镇","白云乡","沧沟乡","凤来乡","浩口乡","和顺乡","后坪乡","黄莺乡","接龙乡","庙垭乡","石桥乡","双河乡","铁矿乡","土地乡","文复乡","赵家乡","县城内"],"重庆 丰都县":["三合街道","南天湖镇","许明寺镇","包鸾镇","董家镇","高家镇","虎威镇","江池镇","龙河镇","名山镇","三元镇","社坛镇","十直镇","树人镇","双路镇","武平镇","兴义镇","湛普镇","镇江镇","太平坝乡","双龙场乡","保合乡","崇兴乡","都督乡","暨龙乡","栗子乡","龙孔乡","青龙乡","仁沙乡","三坝乡","三建乡","县城内"],"重庆 奉节县":["永安镇","白帝镇","草堂镇","大树镇","汾河镇","公平镇","甲高镇","康乐镇","青龙镇","吐祥镇","新民镇","兴隆镇","羊市镇","朱衣镇","竹园镇","安坪乡","冯坪乡","鹤峰乡","红土乡","康坪乡","龙桥乡","平安乡","石岗乡","太和乡","五马乡","新政乡","岩湾乡","云雾乡","长安乡","县城内"],"重庆 开县":["汉丰街道","白鹤街道","丰乐街道","镇东街道","九龙山镇","大进镇","敦好镇","高桥镇","郭家镇","和谦镇","河堰镇","厚坝镇","临江镇","南门镇","南雅镇","渠口镇","铁桥镇","温泉镇","义和镇","长沙镇","赵家镇","镇安镇","中和镇","竹溪镇","三汇口乡","白桥乡","大德乡","关面乡","金峰乡","麻柳乡","满月乡","谭家乡","天和乡","巫山镇","五通乡","紫水乡","县城内","云枫街道","文峰街道","白桥镇","大德镇","金峰镇","谭家镇","天和镇","白泉乡"],"重庆 云阳县":["双江街道","青龙街道","云阳镇","巴阳镇","凤鸣镇","高阳镇","故陵镇","红狮镇","黄石镇","江口镇","龙角镇","路阳镇","南溪镇","农坝镇","盘龙镇","平安镇","渠马镇","人和镇","桑坪镇","沙市镇","双土镇","鱼泉镇","云安镇","洞鹿乡","后叶乡","龙洞乡","毛坝乡","泥溪乡","票草乡","普安乡","栖霞乡","清水乡","上坝乡","石门乡","双龙乡","水口乡","外郎乡","新津乡","堰坪乡","养鹿乡","耀灵乡","云硐乡","县城内"],"重庆 忠县":["忠州镇","拔山镇","白石镇","东溪镇","复兴镇","官坝镇","花桥镇","黄金镇","金鸡镇","马灌镇","任家镇","汝溪镇","三汇镇","石宝镇","石黄镇","双桂镇","乌杨镇","新生镇","洋渡镇","野鹤镇","永丰镇","金声乡","磨子乡","善广乡","石子乡","涂井乡","兴峰乡","新立镇","县城内"],"重庆 巫溪县":["城厢镇","凤凰镇","古路镇","尖山镇","宁厂镇","上磺镇","文峰镇","下堡镇","徐家镇","朝阳洞乡","大河乡","峰灵乡","花台乡","兰英乡","菱角乡","蒲莲乡","胜利乡","双阳乡","塘坊乡","天星乡","天元乡","田坝乡","通城乡","土城乡","乌龙乡","鱼鳞乡","长桂乡","中岗乡","中梁乡","县城内"],"重庆 巫山县":["巫峡镇","大昌镇","福田镇","官渡镇","官阳镇","龙溪镇","骡坪镇","庙堂乡","庙宇镇","双龙镇","铜鼓镇","抱龙镇","大溪乡","当阳乡","邓家乡","笃坪乡","红椿乡","建平乡","金坪乡","两坪乡","龙井乡","培石乡","平河乡","曲尺乡","三溪乡","竹贤乡","县城内"],"重庆 石柱县":["南宾镇","黄水镇","临溪镇","龙沙镇","马武镇","沙子镇","王场镇","西沱镇","下路镇","沿溪镇","渔池镇","悦崃镇","大歇乡","枫木乡","河嘴乡","黄鹤乡","金铃乡","金竹乡","冷水乡","黎场乡","六塘乡","龙潭乡","桥头乡","三河乡","三益乡","石家乡","万朝乡","王家乡","洗新乡","新乐乡","中益乡","县城内"],"重庆 彭水县":["汉葭街道","保家镇","高谷镇","黄家镇","连湖镇","龙射镇","鹿角镇","普子镇","桑柘镇","万足镇","郁山镇","梅子垭乡","鞍子乡","大垭乡","棣棠乡","靛水乡","朗溪乡","联合乡","龙塘乡","龙溪乡","芦塘乡","鹿鸣乡","平安乡","迁乔乡","乔梓乡","润溪乡","三义乡","善感乡","石柳乡","石盘乡","双龙乡","太原乡","桐楼乡","小厂乡","新田乡","岩东乡","长滩乡","诸佛乡","走马乡","县城内"],"重庆 垫江县":["桂溪镇","澄溪镇","高安镇","高峰镇","鹤游镇","普顺镇","沙坪镇","太平镇","五洞镇","新民镇","砚台镇","永安镇","周嘉镇","白家乡","包家乡","曹回乡","大石乡","杠家乡","黄沙乡","裴兴乡","三溪乡","沙河乡","永平乡","长龙乡","坪山镇","县城内"],"重庆 酉阳县":["钟多镇","苍岭镇","车田乡","大溪镇","丁市镇","泔溪镇","龚滩镇","黑水镇","后溪镇","李溪镇","龙潭镇","麻旺镇","小河镇","兴隆镇","酉酬镇","南腰界乡","后坪坝乡","板溪乡","官清乡","花田乡","江丰乡","可大乡","浪坪乡","两罾乡","毛坝乡","庙溪乡","木叶乡","楠木乡","偏柏乡","清泉乡","双泉乡","天馆乡","铜鼓乡","涂市乡","万木乡","五福乡","宜居乡","腴地乡","板桥乡","县城内"],"重庆 秀山县":["清溪场镇","中和镇","隘口镇","峨溶镇","官庄镇","洪安镇","兰桥镇","龙池镇","梅江镇","平凯镇","溶溪镇","石堤镇","石耶镇","雅江镇","巴家乡","保安乡","岑溪乡","大溪乡","干川乡","膏田乡","官舟乡","海洋乡","里仁乡","妙泉乡","平马乡","宋农乡","溪口乡","孝溪乡","涌洞乡","中平乡","钟灵乡","县城内"],"重庆 城口县":["葛城镇","巴山镇","高观镇","庙坝镇","明通镇","坪坝镇","修齐镇","北屏乡","东安乡","高楠乡","高燕乡","河鱼乡","厚坪乡","鸡鸣乡","岚天乡","蓼子乡","龙田乡","明中乡","双河乡","咸宜乡","沿河乡","治平乡","周溪乡","左岚乡","县城内"],"重庆 璧山县":["县城内","璧城街道","璧泉街道","青杠街道","来凤街道","丁家街道","大路街道","八塘镇","七塘镇","河边镇","福禄镇","大兴镇","正兴镇","广普镇","三合镇","健龙镇"],"重庆 荣昌县":["县城内","昌元街道","昌洲街道","广顺街道","安富街道","峰高街道","双河街道","直升镇","路孔镇","清江镇","仁义镇","河包镇","古昌镇","吴家镇","观胜镇","铜鼓镇","清流镇","盘龙镇","远觉镇","清升镇","荣隆镇","龙集镇"],"重庆 铜梁县":["县城内","巴川街道","东城街道","南城街道","土桥镇","二坪镇","水口镇","安居镇","白羊镇","平滩镇","石鱼镇","福果镇","维新镇","高楼镇","大庙镇","围龙镇","华兴镇","永嘉镇","安溪镇","西河镇","太平镇","旧县镇","虎峰镇","少云镇","蒲吕镇","侣俸镇","小林乡","双山乡","庆隆乡"],"重庆 合川区":["南津街道","合阳城街道","钓鱼城街道","草街街道","盐井街道","云门街道","大石街道","沙鱼镇","官渡镇","涞滩镇","肖家镇","古楼镇","三庙镇","二郎镇","龙凤镇","隆兴镇","铜溪镇","双凤镇","狮滩镇","清平镇","土场镇","小沔镇","三汇镇","香龙镇","钱塘镇","龙市镇","燕窝镇","太和镇","渭沱镇","双槐镇"],"重庆 巴南区":["鱼洞街道","花溪街道","龙洲湾街道","李家沱街道","南泉街道","一品街道","南彭街道","惠民街道","麻柳嘴镇","天星寺镇","双河口镇","界石镇","安澜镇","跳石镇","木洞镇","丰盛镇","二圣镇","东泉镇","姜家镇","接龙镇","石滩镇","石龙镇"],"重庆 北碚区":["北温泉街道","龙凤桥街道","天生街道","东阳街道","朝阳街道","蔡家岗镇","童家溪镇","施家梁镇","金刀峡镇","澄江镇","水土镇","歇马镇","天府镇","复兴镇","静观镇","柳荫镇","三圣镇"],"重庆 江津区":["几江街道","德感街道","鼎山街道","双福街道","四面山镇","支坪镇","白沙镇","珞璜镇","柏林镇","蔡家镇","慈云镇","杜市镇","广兴镇","嘉平镇","贾嗣镇","李市镇","龙华镇","石蟆镇","石门镇","塘河镇","吴滩镇","西湖镇","夏坝镇","先锋镇","永兴镇","油溪镇","中山镇","朱杨镇"],"重庆 渝北区":['双凤桥街道','双龙湖街道','大竹林街道','天宫殿街道','翠云街道','人和街道','鸳鸯街道','礼嘉街道','回兴街道','龙山街道','龙塔街道','龙溪街道','两路街道','王家街道','悦来街道','玉峰山镇','茨竹镇','大盛镇','大塆镇','古路镇','龙兴镇','洛碛镇','木耳镇','石船镇','统景镇','兴隆镇'],"重庆 长寿区":["凤城街道","晏家街道","渡舟街道","江南街道","长寿湖镇","邻封镇","但渡镇","云集镇","双龙镇","龙河镇","石堰镇","云台镇","海棠镇","葛兰镇","新市镇","八颗镇","洪湖镇","万顺镇"],"重庆 永川区":["中山路街道","胜利路街道","南大街街道","卫星湖街道","茶山竹海街道","大安街道","陈食街道","板桥镇","宝峰镇","临江镇","红炉镇","吉安镇","金龙镇","来苏镇","青峰镇","三教镇","双石镇","松溉镇","五间镇","仙龙镇","永荣镇","朱沱镇","何埂镇"],"重庆 江北区":["内环以内","寸滩街道","郭家沱街道","铁山坪街道","鱼嘴镇","复盛镇","五宝镇","大石坝街道"],"重庆 南岸区":["内环以内","茶园新区","鸡冠石镇","长生桥镇","峡口镇","广阳镇","迎龙镇","海棠溪街道"],"重庆 九龙坡区":["内环以内","白市驿镇","铜罐驿镇","华岩镇","巴福镇","含谷镇","金凤镇","石板镇","陶家镇","西彭镇","走马镇"],"重庆 沙坪坝区":["内环以内","陈家桥镇","歌乐山镇","青木关镇","回龙坝镇","大学城","虎溪镇","西永镇","土主镇","井口镇","曾家镇","凤凰镇","中梁镇"],"重庆 大渡口区":["内环以内","茄子溪街道","建胜镇","跳磴镇"],"重庆 綦江区":["古南街道","文龙街道","万盛街道","东林街道","三江街道","安稳镇","打通镇","丁山镇","东溪镇","扶欢镇","赶水镇","郭扶镇","横山镇","隆盛镇","三角镇","石壕镇","石角镇","新盛镇","永城镇","永新镇","中峰镇","篆塘镇","丛林镇","关坝镇","黑山镇","金桥镇","南桐镇","青年镇","石林镇","万东镇"],"重庆 渝中区":["全境"],"重庆 高新区":["全境"],"重庆 北部新区":["全境"],"河北 石家庄市":["辛集市","晋州市","新乐市","井陉县","栾城县","行唐县","灵寿县","高邑县","赵县","赞皇县","深泽县","无极县","元氏县","井陉矿区","平山县","藁城市","鹿泉市","正定县","新华区","桥西区","桥东区","裕华区","长安区"],"河北 邯郸市":["邯郸县","峰峰矿区","曲周县","馆陶县","魏县","成安县","大名县","涉县","鸡泽县","邱县","广平县","肥乡县","磁县","临漳县","永年县","丛台区","邯山区","复兴区","武安市"],"河北 邢台市":["邢台县","南宫市","沙河市","柏乡县","任县","清河县","隆尧县","临城县","广宗县","临西县","内丘县","平乡县","巨鹿县","新河县","南和县","宁晋县","威县","桥西区","桥东区"],"河北 保定市":["安国市","满城县","清苑县","涞水县","阜平县","定兴县","唐县","高阳县","容城县","涞源县","望都县","易县","曲阳县","蠡县","顺平县","博野县","雄县","新市区","北市区","南市区","安新县","涿州市","定州市","徐水县","高碑店市"],"河北 张家口市":["宣化县","康保县","张北县","阳原县","赤城县","怀安县","怀来县","崇礼县","尚义县","蔚县","涿鹿县","万全县","下花园区","沽源县","宣化区","桥西区","桥东区"],"河北 承德市":["兴隆县","平泉县","滦平县","丰宁县","围场县","宽城县","隆化县","承德县","双滦区","鹰手营子矿区","双桥区"],"河北 秦皇岛市":["卢龙县","青龙县","昌黎县","北戴河区","抚宁县","海港区","山海关区"],"河北 唐山市":["遵化市","丰南区","迁西县","滦南县","玉田县","曹妃甸区","乐亭县","滦县","古冶区","开平区","路北区","路南区","迁安市","丰润区"],"河北 沧州市":["沧县","泊头市","河间市","献县","肃宁县","青县","东光县","吴桥县","南皮县","盐山县","海兴县","孟村县","运河区","新华区","任丘市","黄骅市"],"河北 廊坊市":["固安县","永清县","香河县","大城县","文安县","大厂县","安次区","广阳区","开发区","三河市","霸州市"],"河北 衡水市":["冀州市","深州市","饶阳县","枣强县","故城县","阜城县","安平县","武邑县","景县","武强县","桃城区"],"山西 太原市":["阳曲县","古交市","娄烦县","清徐县","小店区","迎泽区","晋源区","万柏林区","尖草坪区","杏花岭区"],"山西 大同市":["大同县","天镇县","灵丘县","阳高县","左云县","浑源县","广灵县","新荣区","南郊区","矿区","城区"],"山西 阳泉市":["盂县","平定县","郊区","矿区","城区"],"山西 晋城市":["高平市","阳城县","沁水县","陵川县","泽州县","城 区"],"山西 朔州市":["山阴县","右玉县","应县","怀仁县","朔城区","平鲁区"],"山西 晋中市":["介休市","昔阳县","祁县","左权县","寿阳县","太谷县","和顺县","灵石县","平遥县","榆社县","榆次区"],"山西 忻州市":["原平市","代县","神池县","五寨县","五台县","偏关县","宁武县","静乐县","繁峙县","河曲县","保德县","定襄县","忻府区","岢岚县"],"山西 吕梁市":["离石区","孝义市","汾阳市","文水县","中阳县","兴县","临县","方山县","柳林县","岚县","交口县","交城县","石楼县"],"山西 临汾市":["侯马市","霍州市","汾西县","吉县","安泽县","浮山县","大宁县","古县","隰县","襄汾县","翼城县","永和县","乡宁县","洪洞县","蒲县","曲沃县","尧都区"],"山西 运城市":["河津市","永济市","新绛县","平陆县","垣曲县","绛县","稷山县","芮城县","夏县","临猗县","万荣县","闻喜县","盐湖区"],"山西 长治市":["长治县","潞城市","郊区","襄垣县","屯留县","平顺县","黎城县","壶关县","长子县","武乡县","沁县","沁源县","城区"],"河南 郑州市":["新密市","登封市","上街区","惠济区","金水区","管城区","二七区","中原区","郑东新区","新郑市","巩义市","荥阳市","中牟县","经济开发区","高新技术开发区"],"河南 开封市":["开封县","杞县","兰考县","尉氏县","通许县","金明区","龙亭区","顺河区","鼓楼区","禹王台区"],"河南 洛阳市":['涧西区','西工区','洛龙区','嵩县','偃师市','孟津县','汝阳县','伊川县','洛宁县','宜阳县','栾川县','新安县','伊滨区','吉利区','瀍河区','老城区'
],"河南 平顶山市":["汝州市","舞钢市","郏县","叶县","鲁山县","宝丰县","石龙区","湛河区","卫东区","新华区"],"河南 焦作市":["沁阳市","孟州市","修武县","温县","武陟县","博爱县","山阳区","解放区","马村区","中站区"],"河南 鹤壁市":["浚县","淇县","鹤山区","山城区","淇滨区"],"河南 新乡市":["卫辉市","辉县市","新乡县","获嘉县","原阳县","长垣县","延津县","封丘县","凤泉区","牧野区","红旗区","卫滨区"],"河南 安阳市":["林州市","安阳县","滑县","汤阴县","内黄县","龙安区","殷都区","文峰区","开发区","北关区"],"河南 濮阳市":["濮阳县","南乐县","台前县","清丰县","范县","华龙区"],"河南 许昌市":["禹州市","长葛市","许昌县","鄢陵县","襄城县","魏都区"],"河南 漯河市":["郾城区","临颍县","召陵区","舞阳县","源汇区"],"河南 三门峡市":["义马市","灵宝市","陕县","卢氏县","渑池县","湖滨区"],"河南 南阳市":["邓州市","桐柏县","方城县","淅川县","镇平县","唐河县","南召县","内乡县","新野县","社旗县","西峡县","卧龙区","宛城区"],"河南 商丘市":["永城市","宁陵县","虞城县","民权县","夏邑县","柘城县","睢县","睢阳区","梁园区"],"河南 周口市":["项城市","商水县","淮阳县","太康县","鹿邑县","西华县","扶沟县","沈丘县","郸城县","东新区","经济开发区","川汇区"],"河南 驻马店市":["确山县","新蔡县","上蔡县","泌阳县","西平县","遂平县","汝南县","平舆县","正阳县","驿城区"],"河南 信阳市":['潢川县','淮滨县','息县','新县','固始县','罗山县','光山县','商城县','平桥区','浉河区'
],"河南 济源市":["玉泉街道","北海街道","天坛街道","沁园街道","济水街道","五龙口镇","下冶镇","轵城镇","王屋镇","思礼镇","邵原镇","坡头镇","梨林镇","克井镇","大峪镇","承留镇"],"辽宁 沈阳市":["苏家屯区","新民市","法库县","辽中县","康平县","皇姑区","铁西区","大东区","沈河区","东陵区","于洪区","和平区","浑南新区","沈北新区","道义开发区"],"辽宁 大连市":["普兰店市","瓦房店市","庄河市","长海县","沙河口区","西岗区","中山区","甘井子区","高新园区","大连开发区","金州区","旅顺口区"],"辽宁 鞍山市":["台安县","海城市","岫岩县","铁东区","立山区","铁西区","千山区"],"辽宁 抚顺市":["抚顺县","新宾县","清原县","望花区","东洲区","新抚区","顺城区"],"辽宁 本溪市":["桓仁县","南芬区","本溪县","平山区","溪湖区","明山区"],"辽宁 丹东市":["宽甸县","元宝区","振兴区","振安区","东港市","凤城市"],"辽宁 锦州市":["义县","凌海市","北镇市","黑山县","古塔区","凌河区","太和区","经济技术开发区"],"辽宁 葫芦岛市":["绥中县","建昌县","南票区","龙港区","连山区","兴城市"],"辽宁 营口市":["大石桥市","盖州市","老边区","西市区","站前区","鲅鱼圈区"],"辽宁 盘锦市":["盘山县","大洼县","兴隆台区","双台子区"],"辽宁 阜新市":["阜新县","彰武县","清河门区","新邱区","海州区","太平区","细河区","阜新蒙古族自治县"],"辽宁 辽阳市":["辽阳县","太子河区","弓长岭区","宏伟区","白塔区","文圣区","灯塔市"],"辽宁 朝阳市":["凌源市","北票市","喀喇沁左翼县","朝阳县","建平县","龙城区","双塔区"],"辽宁 铁岭市":["银州区","清河区","开原市","铁岭县","西丰县","昌图县","调兵山市"],"吉林 长春市":["榆树市","九台市","农安县","德惠市","双阳区","朝阳区","南关区","宽城区","二道区","绿园区","净月区","汽车产业开发区","高新技术开发区","经济技术开发区"],"吉林 吉林市":["舒兰市","桦甸市","蛟河市","磐石市","永吉县","昌邑区","龙潭区","船营区","丰满区"],"吉林 四平市":["公主岭市","双辽市","梨树县","伊通县","铁东区","铁西区"],"吉林 通化市":["梅河口市","集安市","通化县","辉南县","柳河县","二道江区","东昌区"],"吉林 白山市":["临江市","江源区","靖宇县","抚松县","长白县","浑江区"],"吉林 松原市":["乾安县","长岭县","扶余县","宁江区","前郭县"],"吉林 白城市":["大安市","洮南市","通榆县","镇赉县","洮北区"],"吉林 延边州":["图们市","敦化市","珲春市","龙井市","和龙市","汪清县","安图县","延吉市"],"吉林 辽源市":["龙山区","西安区","东丰县","东辽县"],"黑龙江 哈尔滨市":["阿城区","尚志市","双城市","五常市","方正县","宾县","依兰县","巴彦县","通河县","木兰县","延寿县","呼兰区","松北区","道里区","南岗区","道外区","香坊区","平房区"],"黑龙江 齐齐哈尔市":["梅里斯区","昂昂溪区","富拉尔基区","碾子山区","讷河市","富裕县","拜泉县","甘南县","依安县","克山县","龙江县","克东县","泰来县","建华区","龙沙区","铁锋区"],"黑龙江 鹤岗市":["萝北县","绥滨县","兴山区","向阳区","工农区","南山区","兴安区","东山区"],"黑龙江 双鸭山市":["集贤县","宝清县","友谊县","饶河县","尖山区","岭东区","四方台区","宝山区"],"黑龙江 鸡西市":["密山市","虎林市","鸡东县","恒山区","滴道区","梨树区","城子河区","麻山区","鸡冠区"],"黑龙江 大庆市":["萨尔图区","龙凤区","让胡路区","红岗区","大同区","林甸县","肇州县","肇源县","杜尔伯特县"],"黑龙江 伊春市":["铁力市","嘉荫县","伊春区　","南岔区","友好区","西林区","翠峦区","新青区","美溪区","金山屯区","五营区","乌马河区","汤旺河区","带岭区","乌伊岭区　","红星区","上甘岭区"],"黑龙江 牡丹江市":["海林市","宁安市","穆棱市","林口县","东宁县","爱民区","东安区","阳明区","西安区","绥芬河市"],"黑龙江 佳木斯市":["同江市","富锦市","桦川县","抚远县","桦南县","汤原县","前进区","向阳区","东风区","郊区"],"黑龙江 七台河市":["勃利县","桃山区","新兴区","茄子河区"],"黑龙江 黑河市":["北安市","五大连池市","逊克县","孙吴县","嫩江县","爱辉区"],"黑龙江 绥化市":["安达市","肇东市","海伦市","绥棱县","兰西县","明水县","青冈县","庆安县","望奎县","北林区"],"黑龙江 大兴安岭地区":["呼玛县","塔河县","漠河县","加格达奇区","松岭区","呼中区","新林区"],"内蒙古 呼和浩特市":["土默特左旗","和林格尔县","武川县","托克托县","清水河县","玉泉区","赛罕区","回民区","新城区"],"内蒙古 包头市":["固阳县","土默特右旗","达茂联合旗","石拐区","白云矿区","东河区","九原区","青山区","昆都仑区"],"内蒙古 乌海市":["海勃湾区","海南区","乌达区"],"内蒙古 赤峰市":["宁城县","敖汉旗","喀喇沁旗","翁牛特旗","巴林右旗","林西县","克什克腾旗","巴林左旗","阿鲁科尔沁旗","元宝山区","松山区","红山区"],"内蒙古 乌兰察布市":["集宁区","丰镇市","兴和县","卓资县","商都县","凉城县","化德县","察哈尔右翼前旗","察哈尔右翼中旗","察哈尔右翼后旗","四子王旗"],"内蒙古 锡林郭勒盟":["锡林浩特市","二连浩特市","多伦县","阿巴嘎旗","西乌珠穆沁旗","东乌珠穆沁旗","苏尼特右旗","苏尼特左旗","太仆寺旗","正镶白旗","正蓝旗","镶黄旗"],"内蒙古 呼伦贝尔市":["海拉尔区","满洲里市","牙克石市","扎兰屯市","根河市","额尔古纳市","陈巴尔虎旗","阿荣旗","新巴尔虎左旗","新巴尔虎右旗","鄂伦春旗","莫力达瓦旗","鄂温克族旗"],"内蒙古 鄂尔多斯市":["东胜区","准格尔旗","伊金霍洛旗","乌审旗","杭锦旗","鄂托克旗","鄂托克前旗","达拉特旗","康巴什新区"],"内蒙古 巴彦淖尔市":["临河区","五原县","磴口县","杭锦后旗","乌拉特中旗","乌拉特后旗 ","乌拉特前旗 "],"内蒙古 阿拉善盟":["阿拉善右旗","阿拉善左旗","额济纳旗"],"内蒙古 兴安盟":["乌兰浩特市","阿尔山市","突泉县","扎赍特旗","科尔沁右翼前旗","科尔沁右翼中旗"],"内蒙古 通辽市":["霍林郭勒市","开鲁县","库伦旗","奈曼旗","扎鲁特旗","科尔沁左翼中旗","科尔沁左翼后旗","科尔沁区"],"江苏 南京市":["江宁区","高淳区","六合区","溧水区","玄武区","秦淮区","建邺区","鼓楼区","栖霞区","雨花台区","浦口区"],"江苏 徐州市":["铜山区","睢宁县","沛县","丰县","贾汪区","金山桥开发区","铜山经济技术开发区","八段工业园区","鼓楼区","邳州市","泉山区","新沂市","云龙区"],"江苏 连云港市":["赣榆县","灌云县","东海县","灌南县","连云区","海州区","新浦区"],"江苏 淮安市":["楚州区","洪泽县","金湖县","盱眙县","经济开发区","清河区","淮阴区","清浦区","涟水县"],"江苏 宿迁市":["宿豫区","泗洪县","宿城区","沭阳县","泗阳县","宿迁经济开发区"],"江苏 盐城市":["东台市","大丰市","建湖县","响水县","阜宁县","滨海县","射阳县","亭湖区","盐都区"],"江苏 扬州市":["广陵区","邗江区","宝应县","仪征市","高邮市","江都区"],"江苏 泰州市":["泰兴市","靖江市","兴化市","高港区","海陵区","姜堰市"],"江苏 南通市":["通州区","如东县","海安县","港闸区","崇川区","南通经济技术开发区","如皋市","海门市","启东市"],"江苏 镇江市":["扬中市","丹徒区","润州区","京口区","镇江新区","丹阳市","句容市","丹徒新区"],"江苏 常州市":["金坛市","溧阳市","新北区","戚墅堰区","钟楼区","天宁区","武进区"],"江苏 无锡市":["崇安区","南长区","北塘区","锡山区","惠山区","新区","江阴市","宜兴市","滨湖区"],"江苏 苏州市":["常熟市","张家港市","相城区","金阊区","虎丘区","平江区","沧浪区","工业园区","高新区","太仓市","吴江区","吴中区","昆山市"],"山东 济南市":["长清区","平阴县","济阳县","商河县","高新区","历城区","天桥区","槐荫区","历下区","市中区","章丘市"],"山东 青岛市":["莱西市","四方区","市北区","市南区","李沧区","黄岛区","即墨市","城阳区","崂山区","胶州市","平度市"],"山东 淄博市":["高青县","沂源县","桓台县","周村区","淄川区","博山区","临淄区","张店区"],"山东 枣庄市":["山亭区","台儿庄区","峄城区","薛城区","市中区","滕州市"],"山东 东营市":["河口区","广饶县","利津县","垦利县","东营区"],"山东 潍坊市":["青州市","诸城市","安丘市","高密市","昌邑市","昌乐县","临朐县","坊子区","潍城区","奎文区","高新区","寒亭区","寿光市"],"山东 烟台市":["莱阳市","招远市","蓬莱市","栖霞市","海阳市","长岛县","芝罘区","莱山区","福山区","牟平区","龙口市","莱州市","开发区"],"山东 威海市":["乳山市","工业新区","环翠区","荣成市","文登市"],"山东 莱芜市":["莱城区","钢城区"],"山东 德州市":["乐陵市","禹城市","陵县","宁津县","武城县","庆云县","平原县","临邑县","夏津县","德城区","齐河县"],"山东 临沂市":["沂南县","沂水县","苍山县","费县","平邑县","蒙阴县","临沭县","莒南县 ","郯城县","罗庄区","兰山区","河东区"],"山东 聊城市":["临清市","阳谷县","茌平县","莘县","东阿县","冠县","高唐县","东昌府区"],"山东 滨州市":["邹平县","沾化县","惠民县","博兴县","阳信县","无棣县","北海新区","滨城区"],"山东 菏泽市":["单县","曹县","定陶县","巨野县","成武县","东明县","郓城县","鄄城县","牡丹区"],"山东 日照市":["五莲县","莒县","岚山区","新市区","东港区"],"山东 泰安市":["东平县","宁阳县","岱岳区","泰山区","肥城市","新泰市"],"山东 济宁市":["梁山县","兖州市","微山县","汶上县","泗水县","嘉祥县","鱼台县","金乡县","任城区","邹城市","市中区","曲阜市","高新区"],"安徽 铜陵市":["铜官山区","郊区","狮子山区","铜陵县"],"安徽 合肥市":["肥东县","庐江县","包河区","蜀山区","瑶海区","庐阳区","经济技术开发区","高新技术开发区","北城新区","滨湖新区","政务文化新区","新站综合开发试验区","肥西县","巢湖市","长丰县"],"安徽 淮南市":["凤台县","田家庵区","大通区","谢家集区","八公山区","潘集区","淮南高新技术开发区"],"安徽 淮北市":["杜集区","烈山区","濉溪县","相山区"],"安徽 芜湖市":["芜湖县","繁昌县","南陵县","无为县","镜湖区","弋江区","鸠江区","三山区"],"安徽 蚌埠市":["怀远县","固镇县","五河县","蚌山区","淮上区","龙子湖区","禹会区"],"安徽 马鞍山市":["当涂县","含山县","和县","博望区","花山区","雨山区"],"安徽 安庆市":["桐城市","宿松县","枞阳县","太湖县","怀宁县","岳西县","望江县","潜山县","开发区","大观区","宜秀区","迎江区"],"安徽 黄山市":["休宁县","歙县","黟县","祁门县","黄山区","徽州区","屯溪区"],"安徽 滁州市":["明光市","全椒县","来安县","定远县","凤阳县","南谯区","琅琊区","天长市"],"安徽 阜阳市":["界首市","太和县","阜南县","颍上县","临泉县","经济开发区","颍泉区","颍州区","颍东区"],"安徽 亳州市":["利辛县","蒙城县","涡阳县","谯城区"],"安徽 宿州市":['经济开发区','埇桥区','灵璧县','泗县','萧县','砀山县'
],"安徽 池州市":["东至县","石台县","青阳县","贵池区"],"安徽 六安市":["寿县","霍山县","金寨县","霍邱县","舒城县","金安区","裕安区"],"安徽 宣城市":["泾县","旌德县","宁国市","郎溪县","广德县","绩溪县","宣州区"],"浙江 宁波市":["慈溪市","奉化市","宁海县","象山县","海曙区","江东区","高新科技开发区","北仑区","镇海区","鄞州区","江北区","余姚市"],"浙江 杭州市":["余杭区","萧山区","富阳市","桐庐县","建德市","淳安县","江干区","滨江区","上城区","下城区","拱墅区","西湖区","下沙区","临安市"],"浙江 温州市":["文成县","平阳县","泰顺县","洞头县","苍南县","龙湾区","茶山高教园区","瑞安市","乐清市","鹿城区","瓯海区","永嘉县"],"浙江 嘉兴市":["海宁市","海盐县","南湖区","秀洲区","桐乡市","平湖市","嘉善县"],"浙江 湖州市":["长兴县","德清县","安吉县","南浔区","吴兴区"],"浙江 绍兴市":["诸暨市","上虞区","嵊州市","新昌县","柯桥区","越城区"],"浙江 金华市":["金东区","兰溪市","婺城区","义乌市","东阳市","永康市","武义县","浦江县","磐安县"],"浙江 衢州市":["江山市","常山县","开化县","龙游县","柯城区","衢江区"],"浙江 丽水市":["龙泉市","缙云县","遂昌县","松阳县","景宁县","云和县","青田县","庆元县","莲都区"],"浙江 台州市":["临海市","三门县","天台县","仙居县","黄岩区","椒江区","路桥区","温岭市","玉环县"],"浙江 舟山市":["岱山县","嵊泗县","普陀区","定海区"],"福建 福州市":["长乐市","平潭县","连江县","罗源县","永泰县","闽清县","台江区","鼓楼区","晋安区","仓山区","马尾区","福清市","闽侯县"],"福建 厦门市":["思明区","湖里区","翔安区","海沧区","集美区","同安区"],"福建 三明市":["永安市","明溪县","将乐县","大田县","宁化县","建宁县","沙县","尤溪县","清流县","泰宁县","梅列区","三元区"],"福建 莆田市":["仙游县","涵江区","秀屿区","城厢区","荔城区"],"福建 泉州市":["石狮市","南安市","惠安县","安溪县","德化县","永春县","泉港区","金门县","洛江区","鲤城区","丰泽区","晋江市"],"福建 漳州市":["龙海市","平和县","南靖县","诏安县","漳浦县","华安县","云霄县","东山县","长泰县","芗城区","龙文区"],"福建 南平市":["建瓯市","邵武市","武夷山市","建阳市","松溪县","顺昌县","浦城县","政和县","光泽县 ","延平区"],"福建 龙岩市":["漳平市","长汀县","武平县","永定县","上杭县","连城县","新罗区"],"福建 宁德市":["福安市","福鼎市","寿宁县","霞浦县","柘荣县","屏南县","古田县","周宁县","蕉城区","东侨开发区"],"湖北 武汉市":['硚口区','武昌区','武汉经济技术开发区','江岸区','江汉区','蔡甸区','江夏区','新洲区','黄陂区','汉阳区','青山区','洪山区','汉南区','东西湖区'],"湖北 黄石市":["黄石港区","铁山区","大冶市","阳新县","下陆区","西塞山区","经济技术开发区"],"湖北 襄阳市":["老河口市","枣阳市","宜城市","南漳县","保康县","谷城县","樊城区","襄城区","襄州区"],"湖北 十堰市":["丹江口市","房县","竹山县","竹溪县","郧县","郧西县","茅箭区","张湾区"],"湖北 荆州市":["江陵县","洪湖市","石首市","松滋市","监利县","公安县","沙市区","荆州区"],"湖北 宜昌市":['伍家岗区','西陵区','宜都市','猇亭区','点军区','当阳市','枝江市','夷陵区','秭归县','兴山县','远安县','五峰土家族自治县','长阳土家族自治县'],"湖北 孝感市":["汉川市","云梦县","大悟县","孝昌县","孝南区","应城市","安陆市"],"湖北 黄冈市":["红安县","罗田县","黄梅县","英山县","团风县","黄州区","蕲春县","麻城市","武穴市","浠水县"],"湖北 咸宁市":["嘉鱼县","通山县","崇阳县","通城县","咸安区","赤壁市"],"湖北 恩施州":["恩施市","利川市","建始县","来凤县","巴东县","鹤峰县","宣恩县","咸丰县"],"湖北 鄂州市":["梁子湖区","华容区","鄂城区"],"湖北 荆门市":["京山县","钟祥市","沙洋县","掇刀区","东宝区"],"湖北 随州市":["广水市","曾都区","随县"],"湖北 潜江市":["园林","杨市","周矶","广华","泰丰","竹根滩镇","高石碑镇","积玉口镇","渔洋镇","王场镇","熊口镇","老新镇","浩口镇","张金镇","龙湾镇","江汉石油管理局","潜江经济开发区","西大垸管理区","运粮湖管理区","周矶管理区","后湖管理区","熊口管理区","总口管理区","高场原种场","浩口原种场","江汉石油管理局"],"湖北 天门市":["侨乡街道开发区","竟陵街道","杨林街道","佛子山镇","多宝镇","拖市镇","张港镇","蒋场镇","汪场镇","渔薪镇","黄潭镇","岳口镇","横林镇","彭市镇","麻洋镇","多祥镇","干驿镇","马湾镇","卢市镇","小板镇","九真镇","皂市镇","胡市镇","石河镇","净潭乡","蒋湖农场","白茅湖农场","沉湖管委会"],"湖北 仙桃市":["龙华山街道","沙嘴街道","干河街道","郑场镇","毛嘴镇","豆河镇","三伏潭镇","胡场镇","长倘口镇","西流河镇","沙湖镇","杨林尾镇","彭场镇","张沟镇","郭河镇","沔城镇","通海口镇","陈场镇","工业园区","九合垸原种场","沙湖原种场","排湖渔场","五湖渔场","赵西垸林场","刘家垸林场","畜禽良种场"],"湖北 神农架林区":["松柏镇","阳日镇","木鱼镇","红坪镇","新华镇","宋洛乡","九湖乡","下谷坪乡"],"湖南 长沙市":["望城区","芙蓉区","岳麓区","雨花区","开福区","天心区","浏阳市","长沙县","宁乡县"],"湖南 株洲市":["醴陵市","株洲县","攸县","茶陵县","炎陵县","天元区","石峰区","芦淞区","荷塘区"],"湖南 湘潭市":["湘乡市","湘潭县","韶山市","雨湖区","岳塘区"],"湖南 韶山市":["韶山市区内"],"湖南 衡阳市":["常宁市","衡阳县","耒阳市","衡东县","衡南县","衡山县","祁东县","南岳区","蒸湘区","石鼓区","珠晖区","雁峰区"],"湖南 邵阳市":["武冈市","邵东县","洞口县","新邵县","绥宁县","新宁县","邵阳县","隆回县","城步县","大祥区","双清区","北塔区"],"湖南 岳阳市":["临湘市","汨罗市","岳阳县","湘阴县","华容县","平江县","君山区","云溪区","岳阳楼区"],"湖南 常德市":["津市市","澧县","临澧县","桃源县","汉寿县","石门县","安乡县","鼎城区","武陵区"],"湖南 张家界市":["慈利县","桑植县","武陵源区","永定区"],"湖南 郴州市":["资兴市","宜章县","安仁县","汝城县","嘉禾县","临武县","桂东县","永兴县","桂阳县","北湖区","苏仙区"],"湖南 益阳市":["南县","桃江县","安化县","沅江市","赫山区","资阳区"],"湖南 永州市":["祁阳县","双牌县","道县","江永县","江华县","宁远县","新田县","蓝山县","东安县","零陵区","冷水滩区"],"湖南 怀化市":["洪江市","会同县","溆浦县","辰溪县","靖州县","通道县","芷江县","新晃县","麻阳县","沅陵县","中方县","鹤城区"],"湖南 娄底市":["冷水江市","涟源市","新化县","双峰县","娄星区"],"湖南 湘西州":["吉首市","古丈县","龙山县","永顺县","泸溪县","凤凰县","花垣县","保靖县"],"广东 广州市":["天河区","海珠区","荔湾区","越秀区","番禺区","花都区","萝岗区","白云区","南沙区","黄埔区","增城市","从化市","广州大学城"],"广东 深圳市":["南山区","罗湖区","福田区","宝安区","光明新区","坪山新区","大鹏新区","龙岗区","盐田区","龙华新区"],"广东 珠海市":["斗门区","金湾区","香洲区"],"广东 汕头市":["南澳县","龙湖区","金平区","澄海区","潮阳区","潮南区","濠江区"],"广东 韶关市":["南雄市","乐昌市","仁化县","始兴县","翁源县","新丰县","乳源瑶族自治县","曲江区","武江区","浈江区"],"广东 河源市":["和平县","龙川县","紫金县","连平县","源城区","东源县"],"广东 梅州市":["兴宁市","梅县","蕉岭县","大埔县","丰顺县","五华县","平远县","梅江区"],"广东 惠州市":["龙门县","惠阳区","大亚湾区","惠城区","惠东县","博罗县"],"广东 汕尾市":["陆河县","海丰县","城区","陆丰市"],"广东 东莞市":['长安镇','莞城区','南城区','寮步镇','大岭山镇','横沥镇','常平镇','厚街镇','万江区','樟木头镇','塘厦镇','凤岗镇','大朗镇','东坑镇','清溪镇','企石镇','茶山镇','东城区','虎门镇','黄江镇','石排镇','道滘镇','沙田镇','高埗镇','石龙镇','石碣镇','洪梅镇','麻涌镇','松山湖','桥头镇','望牛墩镇','中堂镇','谢岗镇'],"广东 中山市":["南朗镇","小榄镇","古镇","坦洲镇","黄圃镇","三乡镇","东凤镇","横栏镇","三角镇","南头镇","沙溪镇","五桂山镇","阜沙镇","东升镇","板芙镇","神湾镇","港口镇","大涌镇","火炬开发区","民众镇","东区街道","西区街道","南区街道","石岐区街道","沙朗镇"],"广东 江门市":["台山市","新会区","鹤山市","江海区","蓬江区","开平市","恩平市"],"广东 佛山市":["顺德区","禅城区","高明区","三水区","南海区"],"广东 阳江市":["阳春市","阳西县","江城区","阳东县"],"广东 湛江市":["雷州市","吴川市","徐闻县","坡头区","赤坎区","霞山区","经济技术开发区","麻章区","遂溪县","廉江市"],"广东 茂名市":["信宜市","茂南区","电白县","高州市","化州市","茂港区"],"广东 肇庆市":["广宁县","德庆县","怀集县","封开县","鼎湖区","端州区","四会市","高要市"],"广东 云浮市":["云安县","新兴县","郁南县","云城区","罗定市"],"广东 清远市":["连州市","佛冈县","阳山县","清新县","连山县","连南县","清城区","英德市"],"广东 潮州市":["饶平县","枫溪区","湘桥区","潮安县"],"广东 揭阳市":["揭西县","惠来县","东山区","普宁市","榕城区","揭东县"],"广西 南宁市":["武鸣县","邕宁区","宾阳县","横县","上林县","隆安县","马山县","良庆区","江南区","兴宁区","青秀区","西乡塘区"],"广西 柳州市":["柳江县","柳城县","鹿寨县","融安县","三江县","融水县","鱼峰区","城中区","柳南区","柳北区"],"广西 桂林市":["阳朔县","临桂县","灵川县","全州县","平乐县","兴安县","灌阳县","荔浦县","资源县","永福县","龙胜县","恭城县","象山区","雁山区","秀峰区","叠彩区","七星区"],"广西 梧州市":["岑溪市","苍梧县","藤县","蒙山县","万秀区","蝶山区","长洲区"],"广西 北海市":["合浦县","铁山港区","海城区","银海区"],"广西 防城港市":["东兴市","上思县","防城区","港口区"],"广西 钦州市":["浦北县","灵山县","钦北区","钦南区"],"广西 贵港市":["桂平市","平南县","覃塘区","港南区","港北区"],"广西 玉林市":["北流市","容县","博白县","陆川县","兴业县","玉州区"],"广西 贺州市":["钟山县","昭平县","富川县","平桂管理区","八步区"],"广西 百色市":["右江区","平果县","乐业县","田阳县","西林县","田林县","德保县","靖西县","田东县","那坡县","隆林县","凌云县"],"广西 河池市":["宜州市","天峨县","凤山县","南丹县","东兰县","巴马县","环江县","罗城县","大化县","都安县","金城江区"],"广西 来宾市":["兴宾区","合山市","忻城县","武宣县","象州县","金秀县"],"广西 崇左市":["江州区","凭祥市","扶绥县","大新县","天等县","宁明县　","龙州县"],"江西 南昌市":["南昌县","进贤县","安义县","新建县","湾里区","青云谱区","西湖区","东湖区","高新区","昌北区","青山湖区","红谷滩新区"],"江西 景德镇市":["乐平市","浮梁县","珠山区","昌江区"],"江西 萍乡市":["湘东区","莲花县","上栗县","芦溪县","安源区"],"江西 新余市":["分宜县","渝水区"],"江西 九江市":["九江县","瑞昌市","星子县","武宁县","彭泽县","永修县","修水县","湖口县","德安县","都昌县","共青城市","经济技术开发区","八里湖新区","庐山风景名胜区","庐山区","浔阳区"],"江西 鹰潭市":["余江县","贵溪市","月湖区"],"江西 上饶市":["德兴市","广丰县","鄱阳县","婺源县","余干县","横峰县","弋阳县","铅山县","玉山县","万年县","信州区","上饶县"],"江西 宜春市":["丰城市","樟树市","高安市","铜鼓县","靖安县","宜丰县","奉新县","万载县","上高县","袁州区"],"江西 抚州市":["南丰县","乐安县","金溪县","南城县","东乡县","资溪县","宜黄县","崇仁县","黎川县","广昌县","临川区"],"江西 吉安市":["井冈山市","吉安县","永丰县","永新县","新干县","泰和县","峡江县","遂川县","安福县","吉水县","万安县","青原区","吉州区"],"江西 赣州市":["南康市","瑞金市","石城县","安远县","赣县","宁都县","寻乌县","兴国县","定南县","上犹县","于都县","龙南县","崇义县","大余县","信丰县","全南县","会昌县","章贡区"],"四川 成都市":["高新西区","新都区","温江区","龙泉驿区","青白江区","彭州市","崇州市","邛崃市","都江堰市","郫县","新津县","双流县","大邑县","蒲江县","金堂县","青羊区","锦江区","金牛区","武侯区","成华区","高新区"],"四川 自贡市":["荣县","富顺县","自流井区","沿滩区","大安区","贡井区"],"四川 攀枝花市":["米易县","盐边县","仁和区","西区","东区"],"四川 泸州市":["泸县","合江县","叙永县","古蔺县","纳溪区","江阳区","龙马潭区"],"四川 绵阳市":["盐亭县","三台县","平武县","北川县","安县","梓潼县","江油市","涪城区","游仙区","高新区","经开区"],"四川 德阳市":["罗江县","中江县","广汉市","什邡市","旌阳区","绵竹市"],"四川 广元市":["青川县","旺苍县","剑阁县","苍溪县","元坝区","朝天区","利州区"],"四川 遂宁市":["射洪县","蓬溪县","大英县","安居区","船山区"],"四川 内江市":["资中县","隆昌县","威远县","市中区","东兴区"],"四川 乐山市":["五通桥区","沙湾区","金口河区","夹江县","井研县","犍为县","沐川县","峨边县","马边县","市中区","峨眉山市"],"四川 宜宾市":["宜宾县","南溪区","江安县","长宁县","兴文县","珙县","高县","屏山县","筠连县","翠屏区"],"四川 广安市":["岳池县","武胜县","邻水县","广安区","华蓥市"],"四川 南充市":["仪陇县","蓬安县","营山县","南部县","顺庆区","高坪区","嘉陵区","西充县","阆中市"],"四川 达州市":["通川区","达县","大竹县","渠县","万源市","宣汉县","开江县"],"四川 巴中市":["南江县","平昌县","通江县","巴州区"],"四川 雅安市":["芦山县","石棉县","名山区","天全县","荥经县","汉源县","宝兴县","雨城区"],"四川 眉山市":["仁寿县","彭山县","洪雅县","丹棱县","青神县","东坡区"],"四川 资阳市":["安岳县","乐至县","雁江区","简阳市"],"四川 阿坝州":["马尔康县","九寨沟县","红原县","阿坝县","理县","若尔盖县","金川县","小金县","黑水县","松潘县","壤塘县","茂县","汶川县"],"四川 甘孜州":["康定县","泸定县","九龙县","丹巴县","道孚县","炉霍县","色达县","甘孜县","新龙县","白玉县","德格县","石渠县","雅江县","理塘县","巴塘县","稻城县","乡城县","得荣县"],"四川 凉山州":["美姑县","昭觉县","会理县","会东县","普格县","宁南县","德昌县","冕宁县","盐源县","金阳县","布拖县","雷波县","越西县","喜德县","甘洛县","木里县","西昌市"],"海南 海口市":["秀英区","龙华区","琼山区","美兰区"],"海南 儋州市":["那大镇","和庆镇","南丰镇","大成镇","雅星镇","兰洋镇","光村镇","木棠镇","海头镇","峨蔓镇","三都镇","王五镇","白马井镇","中和镇","排浦镇","东成镇","新州镇","洋浦经济开发区","富克镇","西培农场","西联农场","蓝洋农场","八一农场","西华农场","西庆农场","西流农场","新盈农场","龙山农场","红岭农场","热作学院"],"海南 琼海市":["嘉积镇","万泉镇","石壁镇","中原镇","博鳌镇","阳江镇","龙江镇","潭门镇","塔洋镇","长坡镇","大路镇","会山镇","彬村山华侨农场","东太农场","东红农场","东升农场","南俸农场"],"海南 万宁市":["万城镇","龙滚镇","和乐镇","后安镇","大茂镇","东澳镇","礼纪镇","长丰镇","山根镇","北大镇","南桥镇","三更罗镇","六连林场","东兴农场","东和农场","新中农场","兴隆华侨农场"],"海南 东方市":["八所镇","东河镇","大田镇","感城镇","板桥镇","三家镇","四更镇","新龙镇","天安乡","江边乡","广坝农场","东方华侨农场"],"海南 三亚市":["海棠湾镇","吉阳镇","凤凰镇","天涯镇","育才镇","崖城镇","河西区","河东区","南田农场","南新农场","南岛农场","立才农场","南滨农场"],"海南 文昌市":["文城镇","重兴镇","蓬莱镇","会文镇","东路镇","潭牛镇","东阁镇","文教镇","东郊镇","龙楼镇","昌洒镇","翁田镇","抱罗镇","冯坡镇","锦山镇","铺前镇","公坡镇","迈号镇","清谰镇","南阳镇","新桥镇","头苑镇","宝芳乡","龙马乡","湖山乡","东路农场","南阳农场","罗豆农场","橡胶研究所"],"海南 五指山市":["通什镇","南圣镇","毛阳镇","番阳镇","畅好乡","毛道乡","水满乡","畅好农场"],"海南 临高县":["临城镇","波莲镇","东英镇","博厚镇","皇桐镇","多文镇","和舍镇","南宝镇","新盈镇","调楼镇","加来镇","红华农场","加来农场","县城内"],"海南 澄迈县":["金江镇","老城镇","瑞溪镇","永发镇","加乐镇","文儒镇","中兴镇","仁兴镇","福山镇","桥头镇","大丰镇","红光农场","西达农场","金安农场","县城内"],"海南 定安县":["定城镇","新竹镇","龙湖镇","雷鸣镇","龙门镇","龙河镇","岭口镇","翰林镇","富文镇","黄竹镇","金鸡岭农场","中瑞农场","南海农场","县城内"],"海南 屯昌县":["屯城镇","新兴镇","枫木镇","乌坡镇","南吕镇","南坤镇","坡心镇","西昌镇","中建农场","中坤农场","县城内"],"海南 昌江县":["石碌镇","叉河镇","十月田镇","乌烈镇","昌化镇","海尾镇","七叉镇","王下乡","海南矿业公司","霸王岭林场","红林农场","县城内"],"海南 白沙县":["牙叉镇","七坊镇","邦溪镇","打安镇","细水乡","元门乡","南开乡","阜龙乡","青松乡","金波乡","荣邦乡","白沙农场","龙江农场","邦溪农场","县城内"],"海南 琼中县":["营根镇","湾岭镇","黎母山镇","和平镇","长征镇","红毛镇","中平镇","上安乡","什运乡","吊罗山乡","黎母山林业公司","阳江农场","乌石农场","加钗农场","长征农场","县城内"],"海南 陵水县":["椰林镇","光坡镇","三才镇","英州镇","隆广镇","文罗镇","本号镇","新村镇","黎安镇","提蒙乡","群英乡","吊罗山林业公司","岭门农场","南平农场","县城内"],"海南 保亭县":["保城镇","什玲镇","加茂镇","响水镇","新政镇","三道镇","六弓乡","南林乡","毛感乡","保亭研究所","新星农场","金江农场","三道农场","县城内"],"海南 乐东县":["抱由镇","万冲镇","大安镇","志仲镇","千家镇","九所镇","利国镇","黄流镇","佛罗镇","尖峰镇","莺歌海镇","尖峰岭林业公司","莺歌海盐场","山荣农场","乐光农场","保国农场","县城内"],"海南 三沙市":["西沙群岛","南沙群岛","中沙群岛"],"贵州 贵阳市":["清镇市","开阳县","修文县","息烽县","乌当区","南明区","白云区","云岩区","花溪区","小河区","观山湖区"],"贵州 六盘水市":["盘县","六枝特区","水城县","钟山区"],"贵州 遵义市":["赤水市","仁怀市","遵义县","桐梓县","绥阳县","习水县","凤冈县","正安县","湄潭县","余庆县","道真县","务川县","红花岗区","汇川区"],"贵州 铜仁市":["碧江区","德江县","江口县","思南县","万山区","石阡县","玉屏侗族自治县","松桃苗族自治县","印江土家族苗族自治县","沿河土家族自治县"],"贵州 毕节市":["黔西县","大方县","织金县","金沙县","赫章县","纳雍县","威宁彝族回族苗族自治县","七星关区"],"贵州 安顺市":["西秀区","普定县","平坝县","镇宁布依族苗族自治县","关岭布依族苗族自治县","紫云苗族布依族自治县"],"贵州 黔西南州":["兴义市","望谟县","兴仁县","普安县","册亨县","晴隆县","贞丰县","安龙县"],"贵州 黔东南州":["凯里市","施秉市","从江县","锦屏县","镇远县","麻江县","台江县","天柱县","黄平县","榕江县","剑河县","三穗县","雷山县","黎平县","岑巩县","丹寨县"],"贵州 黔南州":["都匀市","福泉市","贵定市","惠水县","罗甸县","瓮安县","荔波县","龙里县","平塘县","长顺县","独山县","三都县"],"云南 昆明市":["东川区","安宁市","富民县","嵩明县","晋宁县","宜良县","禄劝县","石林县","寻甸县","盘龙区","五华区","官渡区","西山区","呈贡区"],"云南 曲靖市":["马龙县","宣威市","富源县","会泽县","陆良县","师宗县","罗平县","沾益县","麒麟区"],"云南 玉溪市":["红塔区","华宁县","澄江县","易门县","通海县","江川县","元江县","新平县","峨山县"],"云南 昭通市":["昭阳区","镇雄县","永善县","大关县","盐津县","彝良县","水富县","巧家县","威信县","鲁甸县","绥江县"],"云南 普洱市":["思茅区","宁洱县","景东县","镇沅县","景谷县","墨江县","澜沧县","西盟县","江城县","孟连县"],"云南 临沧市":["临翔区","镇康县","凤庆县","云县","永德县","耿马县","双江县","沧源县"],"云南 保山市":["隆阳区","施甸县","昌宁县","龙陵县","腾冲县"],"云南 丽江市":["玉龙县","华坪县","永胜县","宁蒗县","古城区"],"云南 文山州":["文山市","麻栗坡县","砚山县","广南县","马关县","富宁县","西畴县","丘北县"],"云南 红河州":["个旧市","开远市","弥勒县","红河县","绿春县","蒙自市","泸西县","建水县","元阳县","石屏县","金平县","屏边县","河口县"],"云南 西双版纳州":["景洪市","勐海县","勐腊县"],"云南 楚雄州":["元谋县","南华县","牟定县","武定县","大姚县","双柏县","禄丰县","永仁县","姚安县","楚雄市"],"云南 大理州":["剑川县","弥渡县","云龙县","洱源县","鹤庆县","宾川县","祥云县","永平县","巍山县","漾濞县","南涧县","大理市"],"云南 德宏州":["芒市","瑞丽市","盈江县","梁河县","陇川县"],"云南 怒江州":["泸水县","福贡县","兰坪县","贡山县"],"云南 迪庆州":["香格里拉县","德钦县","维西县"],"西藏 拉萨市":["城关区","林周县","当雄县","尼木县","曲水县","堆龙德庆县","达孜县","墨竹工卡县"],"西藏 那曲地区":["索县","那曲县","嘉黎县","比如县","聂荣县","安多县","申扎县","班戈县","巴青县","尼玛县"],"西藏 山南地区":["贡嘎县","扎囊县","乃东县","桑日县","琼结县","曲松县","措美县","洛扎县","加查县","隆子县","错那县","浪卡子县"],"西藏 昌都地区":["昌都县","江达县","贡觉县","类乌齐县","丁青县","察雅县","八宿县","左贡县","芒康县","洛隆县","边坝县"],"西藏 日喀则地区":["聂拉木县","昂仁县","日喀则市","南木林县","江孜县","定日县","萨迦县　","拉孜县","谢通门县","白朗县","仁布县","康马县","定结县","仲巴县","亚东县","吉隆县","萨嘎县","岗巴县"],"西藏 阿里地区":["噶尔县","普兰县","札达县　","日土县","革吉县","改则县","措勤县"],"西藏 林芝地区":["林芝县","工布江达县","米林县","墨脱县","波密县","察隅县","朗县"],"陕西 西安市":["高陵县","蓝田县","户县","周至县","雁塔区","未央区","长安区","灞桥区","碑林区","新城区","莲湖区","临潼区","阎良区","杨凌农业示范区"],"陕西 铜川市":["印台区","宜君县","王益区","耀州区"],"陕西 宝鸡市":["岐山县","太白县","凤翔县","陇县","麟游县","千阳县","扶风县","凤县","眉县","渭滨区","金台区","陈仓区"],"陕西 咸阳市":["兴平市","礼泉县","泾阳县","永寿县","三原县","彬县","旬邑县","长武县","乾县","武功县","淳化县","秦都区","渭城区","杨陵区"],"陕西 渭南市":["韩城市","华阴市","蒲城县","华县","潼关县","大荔县","澄城县","合阳县","白水县","富平县","临渭区"],"陕西 延安市":["安塞县","洛川县","子长县","黄陵县","延长县","宜川县","延川县","甘泉县","富县","志丹县","黄龙县","吴起县","宝塔区"],"陕西 汉中市":["南郑县","城固县","洋县","佛坪县","留坝县","镇巴县","西乡县","勉县","略阳县","宁强县","汉台区"],"陕西 榆林市":["清涧县","绥德县","佳县","神木县","府谷县","子洲县","横山县","米脂县","吴堡县","定边县","靖边县","榆阳区"],"陕西 商洛市":["商州区","镇安县","山阳县","洛南县","商南县","丹凤县","柞水县"],"陕西 安康市":["紫阳县","岚皋县","旬阳县","镇坪县","平利县","宁陕县","汉阴县","石泉县","白河县","汉滨区"],"甘肃 兰州市":["永登县","榆中县","皋兰县","西固区","红古区","七里河区","安宁区","城关区"],"甘肃 金昌市":["永昌县","金川区"],"甘肃 白银市":["白银区","平川区","靖远县","景泰县","会宁县"],"甘肃 天水市":["甘谷县","武山县","清水县","秦安县","张家川县","麦积区","秦州区"],"甘肃 嘉峪关市":["雄关区","长城区","镜铁区"],"甘肃 平凉市":["华亭县","崇信县","泾川县","灵台县","镇原县","庄浪县","崆峒区","静宁县"],"甘肃 庆阳市":["西峰区","镇原县","合水县","华池县","环县","宁县","正宁县","庆城县"],"甘肃 陇南市":["成县","礼县","康县","武都区","文县","两当县","徽县","宕昌县","西和县"],"甘肃 武威市":["凉州区","古浪县","天祝县","民勤县"],"甘肃 张掖市":["甘州区","山丹县","临泽县","高台县","肃南县","民乐县"],"甘肃 酒泉市":["玉门市","敦煌市","金塔县","阿克塞县","肃北县","瓜州县","肃州区"],"甘肃 甘南州":["合作市","夏河县","碌曲县","舟曲县","玛曲县","迭部县","临潭县","卓尼县"],"甘肃 临夏州":["临夏县","康乐县","永靖县","和政县","东乡族自治县","积石山县","临夏市","广河县"],"甘肃 定西市":["岷县","安定区","通渭县","临洮县","漳县","渭源县","陇西县"],"青海 西宁市":["湟中县","湟源县","大通县","城中区","城东区","城西区","城北区"],"青海 海东地区":["平安县","乐都县","民和县","互助县","化隆县","循化县"],"青海 海北州":["海晏县","祁连县","刚察县","门源县"],"青海 黄南州":["尖扎县","同仁县","泽库县","河南县"],"青海 海南州":["共和县","同德县","贵德县","兴海县","贵南县"],"青海 果洛州":["玛沁县","甘德县","达日县","班玛县","久治县","玛多县"],"青海 玉树州":["玉树县","称多县","囊谦县","杂多县","治多县","曲麻莱县"],"青海 海西州":["德令哈市","乌兰县","天峻县","都兰县","大柴旦行委","冷湖行委","茫崖行委","格尔木市"],"宁夏 银川市":["灵武市","永宁县","贺兰县","兴庆区","金凤区","西夏区"],"宁夏 石嘴山市":["平罗县","惠农区","大武口区"],"宁夏 吴忠市":["青铜峡市","同心县","盐池县","红寺堡开发区","利通区"],"宁夏 固原市":["西吉县","隆德县","泾源县","彭阳县","原州区"],"宁夏 中卫市":["中宁县","海原县","沙坡头区"],"新疆 乌鲁木齐市":["乌鲁木齐县","头屯河区","达坂城区","米东区","天山区","新市区","沙依巴克区","水磨沟区"],"新疆 克拉玛依市":["克拉玛依区","独山子区","白碱滩区","乌尔禾区"],"新疆 石河子市":["石河子市"],"新疆 吐鲁番地区":["吐鲁番市","托克逊县","鄯善县"],"新疆 哈密地区":["哈密市","巴里坤县","伊吾县"],"新疆 和田地区":["和田市","墨玉县","洛浦县","策勒县","于田县","民丰县","皮山县","和田县"],"新疆 阿克苏地区":["阿克苏市","温宿县","沙雅县","拜城县","阿瓦提县","库车县","柯坪县","新和县","乌什县","阿拉尔市"],"新疆 喀什地区":["喀什市","巴楚县","泽普县","伽师县","叶城县","岳普湖县","疏附县","疏勒县","英吉沙县","麦盖提县","莎车县","塔什库尔干县"],"新疆 克孜勒苏州":["阿图什市","阿合奇县","乌恰县","阿克陶县"],"新疆 巴音郭楞州":["库尔勒市","尉犁县","和静县","博湖县","和硕县","轮台县","若羌县","且末县","焉耆县"],"新疆 昌吉州":["昌吉市","阜康市","奇台县","玛纳斯县","吉木萨尔县","呼图壁县","木垒县"],"新疆 博尔塔拉州":["博乐市","精河县","温泉县"],"新疆 伊犁州":["伊宁市","特克斯县","尼勒克县","昭苏县","新源县","霍城县","察布查尔县","巩留县","奎屯市","伊宁县"],"新疆 塔城地区":["塔城市","乌苏市","额敏县","裕民县","沙湾县","托里县","和布克赛尔县"],"新疆 阿勒泰地区":["阿勒泰市","富蕴县","青河县","吉木乃县","布尔津县","福海县","哈巴河县","北屯市"],"新疆 五家渠市":["五家渠市"],"新疆 阿拉尔市":["阿拉尔市"],"新疆 图木舒克市":["图木舒克市"],"台湾 台湾":["台湾市区内"],"香港 香港特别行政区":["香港市区内"],"澳门 澳门市":["澳门市区内"],"钓鱼岛 钓鱼岛":['钓鱼岛'] }
    };
    
    Cascade.prototype.getProvince=function(){
        return data.province;
    };
    Cascade.prototype.getCity=function(province){
        return data.city[province]||[];
    };
    Cascade.prototype.getDistrict=function(province_city){
        return data.district[province_city]||[];
    }
    Cascade.prototype.init = function(province,city,district){
        this.p = document.getElementById(province);
        this.c= document.getElementById(city);
        this.d = document.getElementById(district);
        var _this = this;

        this.select();
        this.p.onchange = function(){
            _this.load('city',{
                p:_this.p.value,
                c:_this.c.value,
                d:_this.d.value
            })
            _this.load('district',{
                p:_this.p.value,
                c:_this.c.value,
                d:_this.d.value
            })
        };
        this.c.onchange = function(){
            _this.load('district',{
                p:_this.p.value,
                c:_this.c.value,
                d:_this.d.value
            })
        }
    }
    Cascade.prototype.load = function(type,data){
        data = data || {
            p:'',
            c:'',
            d:''
        };
        var fn = null;
        var str = '';
        var param = '';
        var select = '';
        var value = '';
        if(type == 'city'){
            fn = this.getCity;
            str = '市/地区/自治州';
            param = data.p;
            select = this.c;
            value = data.c;
        }else if(type == 'district'){
            fn = this.getDistrict;
            str = '区/县';
            param = data.p+' '+data.c;
            select = this.d;
            value = data.d;
        }else{
            fn = this.getProvince;
            str = '省/自治区';
            select = this.p;
            value = data.p;
        }

        var ap = [''].concat(fn(param));
        select.innerHTML = '';
        for(var i=0;i<ap.length;i++){
            var option = new Option();
            option.value = ap[i];
            if(ap[i] != ''){
                option.text = ap[i];
            }else{
                option.text = str;
            }
            select.add(option);

            if(value == ap[i]){
                select.selectedIndex = i;
            }
        }
    }
    Cascade.prototype.select = function(){
        if(!arguments.length){
            this.load('province')
        }
        var data = {
            p:arguments[0],
            c:arguments[1],
            d:arguments[2]
        }
        this.load('province',data)
        this.load('city',data)
        this.load('district',data)
    }
    return Cascade;
})